# 微服务项目结构

### 整体（process）

```
|--online-taxi-three
		|-- 项目A
		|-- 项目B
单独项目
		|--pom
		|--src
				|--controller
				|--service
					impl
					接口
				|--dao
					entity
					mapper
				|--manager service中公共抽取出来的通用逻辑
				|--constant
				|--request 项目接收参数bean
				|--response 项目返回参数bean
		|--resource
			|--mapper
				|--*Mapper.xml
			.yml
```

#### 异常

```
异常：
dao层的异常：catch抛上去，一般不打印日志。/这一层的异常是怎么提前感知的？
在service层打日志，包含详细信息，时间，参数。
controller层必须捕获所有异常，把异常包装成状态码。

UserBean
dto：抽取一些公用bean到common层（二方库，会放在公司私服上，所以叫二方库）
```

#### eureka-server优化

```html
@EnableEurekaServer 和pom中对应的eureka server依赖 组成了eureka-server

eureka自我保护机制，服务数量少关闭自我保护机制（服务挂了可及时剔除），服务数量很多就开启自我保护机制（高可用AP）。

eureka三级缓存
 private final ConcurrentHashMap<String, Map<String, Lease<InstanceInfo>>> registry
            = new ConcurrentHashMap<String, Map<String, Lease<InstanceInfo>>>();
 map<eureka服务名称，map<服务实例id，实例信息>>
 
     registry --数据一致-- readWriteCatchMap --默认30s per sync- readOnlyCacheMap
     所以use-read-only-response-cache: false。不再从readOnlyCacheMap获取数据（不一定是最新的）
     
  #eureka优化方法
  server:
    #自我保护
    enable-self-preservation: false
    #自我保护阈值
    renewal-percent-threshold: 0.85
    #剔除挂掉服务的时间间隔
    eviction-interval-timer-in-ms: 1000
    #关闭从三级缓存中读注册表
    use-read-only-response-cache: false
    #同步二三级缓存的时间间隔
    response-cache-update-interval-ms: 1000

```







